<?php
$iconeleon = ($_SERVER['SERVER_ADDR'] == '127.0.0.1' ?  $_SERVER['REQUEST_SCHEME'] . '://' . $_SERVER['SERVER_NAME'] . '/api/iconeleon/' : 'http://api.warriordudimanche.net/iconeleon/');

$a = [
	'c1' => [
		'a' => 533,
		'b' => 8797,
		'c' => 765,
		'd' => 2978,
		'e' => 7302
	],
	'c2' => [
		'f' => 8973,
		'g' => 72792,
		'h' => 8728
	]
];

$b = json_encode($a);

// echo '<pre style="position:relative;z-index:2000000000;opacity:0.6;border: 1px solid #e3af43; background-color: #f8edd5; padding: 10px;color:#111;white-space: pre;white-space: pre-wrap;word-wrap: break-word;">Fichier '.__FILE__.', LIGNE '.__LINE__.'<br/><strong>$b :</strong> '; print_r($b);exit('</pre>');

?>
<!DOCTYPE html>
<html>
<head>
	<title>Grafit</title>
	<meta charset="utf-8">
	<link rel="stylesheet" type="text/css" href="helium.css">
	<link rel="icon" type="image/svg" href="<?php echo $iconeleon;?>?i=iconic/bars.svg&c=white">
	<style type="text/css">
		html{
			font-family: Arial Rounded MT Bold,Helvetica Rounded,Arial,sans-serif;
			min-width: 320px;
			--theme_color:#3cc5f1;
		}
		header{
			background:var(--theme_color);
			color:white;
			padding:2em;
		}
		header h1{
			font-size:32px;
			max-width: 1200px;
			margin:1em auto;
			padding-left:15px;
		}
		header img{
			height:28px;
			width:auto;
		}
		main{
			max-width: 1200px;
			margin:1em auto;
			padding:15px;
		}
			form>div{
				margin-top:15px;
			}
			label{
				display:block;
				font-size:16px;
			}
			input[type=text],textarea,
			input[type=text]:focus,textarea:focus
			{
				width:100%;
				padding:10px;
				font-size:1.3em;
				border-width: 2px;
			}
			textarea{
				min-height:128px;
				resize:vertical;
				padding:10px;
				font-size:1.3em;
			}

			.icon{height:16px;width:auto;}
			form button{
				color:white;
			}
			div.right{
				display:flex;
				flex-direction: row-reverse;
			}
			form a.btn,form a.btn:hover{background: transparent;border: none}
			#render img{
				display:block;
				margin:auto;
				min-width:64px;
				min-height: 64px;
				width:100%;
				height: auto;
			}
			input[type="radio"]+label{
				display:block;
				width:100%;
				height:48px;
				border-radius: 3px;
				border: 1px solid transparent;
				opacity:0.8;
			}
			input:disabled+label{
				opacity:0.1;
			}
			input[type="radio"]:disabled+label:hover{
				opacity:0.1;
				cursor: initial;
			}
			input[type="radio"]:checked+label{
				opacity:1;
				border-color:rgba(0,0,0,0.5);
			}
			input[type="radio"]+label:hover{
				opacity:1;
			}
			header small{
				display:block;
				text-align: right;
			}
	</style>
</head>
<body>
<header>
	<h1><img src="<?php echo $iconeleon;?>?i=iconic/bars.svg&c=white"/> Grafit</h1>
	<small>v<?php echo VERSION ?></small>
</header>
<main>
	<form action="" method="get" target="_BLANK">
		<div>
			<label>
				Titre du graphique (fac.)
			</label>
			<input type="text" name="title">
		</div>
		<div>
			<label>
				Légende du graphique (fac.)
			</label>
			<input type="text" name="legend" placeholder="unité utilisée, source des données, date des chiffres etc.">
		</div>
		<div>
			<label>
				*Données
			</label>
			<textarea name="data" required="true" placeholder="123,254,569,854,675 ou colonne1:123,colonne2:254,colonne3:569,colonne4:854,colonne5:675 ou chaine json"></textarea>
		</div>
		<div>
			<label>
				Dimensions du graphique
			</label>
			<select name="w">
				<option value="256">256</option>
				<option value="512" selected="selected">512</option>
				<option value="1024">1024</option>
				<option value="1200">1200</option>
				<option value="1600">1600</option>
				<option value="2048">2048</option>
			</select>
			 x
			<select name="h">
				<option value="256" selected="selected">256</option>
				<option value="512">512</option>
				<option value="1024">1024</option>
				<option value="1200">1200</option>
				<option value="1600">1600</option>
				<option value="2048">2048</option>
			</select>
		</div>
		<div>
			<label>
				Type de graphique
			</label>
			<ul>
				<label><input type="radio" name="type" value="bar" onclick="enable('input[name=color]');"> <img class="icon" src="<?php echo $iconeleon;?>?i=typicons/chart-bar.svg&c=black"/> Barres</label>
				<label><input type="radio" name="type" value="lines" onclick="enable('input[name=color]');"> <img class="icon" src="<?php echo $iconeleon;?>?i=typicons/chart-area-outline.svg&c=black"/> Ligne seule</label>
				<label><input type="radio" name="type" value="filled" onclick="enable('input[name=color]');"> <img class="icon" src="<?php echo $iconeleon;?>?i=typicons/chart-area.svg&c=black"/> Ligne + surface pleine</label>
				<label><input type="radio" name="type" value="pie"  onclick="disable('input[name=color]');"> <img class="icon" src="http://api.warriordudimanche.net/iconeleon/?i=typicons/chart-pie.svg&c=black"/> Camenbert</label>
				<label><input type="radio" name="type" value="ring" onclick="disable('input[name=color]');"> <img class="icon" src="<?php echo $iconeleon;?>?i=Bronco%27s/ring-chart.svg&c=black"/> Anneau</label>
				
			</ul>
		</div>
		<div>
			<label>
				Options
			</label>
			<ul>
				<label><input type="checkbox" name="moyenne"> Calculer la moyenne</label>
				<label><input type="checkbox" name="mediane"> Calculer la médiane</label>
				<label><input type="checkbox" name="hidevalues"> Cacher les valeurs</label>
			</ul>
			<label>
				Pas des ordonnées (fac.)
			</label>
			<input type="number" name="steps">
		</div>
		<div>
			<label>
				Couleur (fac.)
			</label>
			<ul class="responsive" style="--responsive_width:64px">
				<?php
					$c=explode(' ','F 9 0');
					foreach ($c as $red) {
						foreach ($c as $green) {
							foreach ($c as $blue) {
								$color=$red.$red.$green.$green.$blue.$blue;
								if (
									(strpos($color, '0')!==false&&strpos($color, 'F')!==false)
									||
									(strpos($color, '9')!==false&&strpos($color, '0')!==false)
									||
									$color=='999999'
								){
									echo "<input type='radio' id='ID$color' name='color' class='hidden' value='$color'/><label for='ID$color' style='background-color:#$color'></label>";
								}
							}
						}
					}
				?>
			</ul>
		</div>

		<div class="columns2">
			<div>
				<a class="btn" href="" title="tout effacer"><img class="icon" src="<?php echo $iconeleon;?>?i=fontawesome%20solid/trash-alt.svg&c=red"></a>
			</div>
			<div class="right">

				<button class="information" name="download"><img class="icon" src="<?php echo $iconeleon;?>?i=cloud-download-alt.svg&c=white" title="Télécharger ce graphique sur cet appareil"/> Télécharger</button>
				<button class="important" name="render"><img class="icon" src="<?php echo $iconeleon;?>?i=eye-open.svg&c=white" title="Voir ce graphique"/> Visualiser</button>

			</div>
		</div>
	</form>
	<hr/>
	<div id="render">
		<img src="<?php echo $iconeleon;?>?i=elusive/picture.svg&c=rgba(0,0,0,0.2)"/>
	</div>

</main>
<script type="text/javascript" src="VanillaJS.js"></script>
<script type="text/javascript">
	function disable($obj){
		attr($obj,"disabled",true);
		first($obj+":checked").checked=false;
	}
	function enable($obj){
		removeAttr($obj,"disabled");
	}
	var textarea=first('textarea');
	var renderpic=first('#render img');
	first('input[name="type"]').checked=true;
	on('click','button',(e)=>{
		e.preventDefault();
		e.stopPropagation();
		let text=textarea.value;
		let array=text.split(',');
		let objet=text.indexOf(':');
		if (objet>-1){
			newarray={};
		}else{
			newarray=[];
		}
		if (!isJSON(text)) {
			if (array.length<2){return;}

			each(array,(item)=>{
				if (objet>-1){
					d=item.split(':');
					if (d.length!=2){
						alert("Il y a une erreur dans les données (valeur "+item+")");
						return;
					}
					newarray[d[0]]=d[1];
				}else{
					newarray.push(item);
				}
			});
		} else {
			newarray = JSON.parse(text);
		}


		// récupération des values
		let selectw=first('select[name="w"]');
		let w=selectw.options[selectw.selectedIndex].value;
		let selecth=first('select[name="h"]');
		let h=selecth.options[selecth.selectedIndex].value;
		let typ=first('input[name="type"]:checked').value;
		let color=first('input[name="color"]:checked');
		let title=first('input[name="title"]').value;
		let legend=first('input[name="legend"]').value;
		let steps=first('input[name="steps"]').value;
		let action=e.target.name;

		if (color){color=color.value;}else{color='';}

		params='index.php?data='+JSON.stringify(newarray)+'&'+typ+"&w="+w+"&h="+h+"&legend="+legend+"&title="+title+"&color="+color;

		if (first('input[name="moyenne"').checked){
			params+="&moyenne";
		}
		if (first('input[name="mediane"').checked){
			params+="&mediane";
		}
		if (first('input[name="hidevalues"').checked){
			params+="&hidevalues";
		}
		if (steps!=''){
			params+="&steps="+steps;
		}

		if (action=="render"){
			params+="&dontsave";
			renderpic.src=params
			console.log(params);
		}else{
			params+="&force";
			a=document.createElement('a');
			a.setAttribute('download',title+" "+Date.now()+".svg");
			Object.assign(a, { target: '_blank', href: params}).click();

		}


	})
</script>
</body>
</html>